<?php
/**
 * 人脸水印照比对WebAPI接口调用示例接口文档(必看)：https://doc.xfyun.cn/rest_api/%E4%BA%BA%E8%84%B8%E6%AF%94%E5%AF%B9.html
 * 上传人脸照片格式必须为JPG（JPEG）,BMP,PNG,GIF,TIFF之一,宽和高必须大于 8px,小于等于 4000px,要求编码后图片大小不超过5M
 * 上传水印照格式 JPG（JPEG），BMP，PNG，TIFF 之一,宽和高必须大于 8px，小于等于 480px,要求编码后图片大小不超过1M
 * (Very Important)创建完webapi应用添加合成服务之后一定要设置ip白名单，找到控制台--我的应用--设置ip白名单，如何设置参考：http://bbs.xfyun.cn/forum.php?mod=viewthread&tid=41891
 * 错误码链接：https://www.xfyun.cn/document/error-code (code返回错误码时必看)
 * @author iflytek
 */
class test {
    function xfyun() {
        $daytime=strtotime('1970-1-1T00:00:00 UTC');
        //weiapi接口地址
        $api = "http://api.xfyun.cn/v1/service/v1/image_identify/watermark_verification";
        // 应用ID (必须为webapi类型应用，并开通人脸水印照比对服务，参考帖子如何创建一个webapi应用：http://bbs.xfyun.cn/forum.php?mod=viewthread&tid=36481)
        $XAppid = "*****";
        // 接口密钥(webapi类型应用开通人脸水印照比对服务后，控制台--我的应用---人脸水印照比对---相应服务的apikey)
        $Apikey = "******";
        $XCurTime =time();
        $XParam ="";
        $XCheckSum ="";
        //是否对图片旋转默认旋转(true)
        $Param= array(
            "auto_rotate"=>true,
        );
        // face_image 需上传的人脸照，base64编码后进行URLEncode,格式必须为JPG（JPEG）,BMP,PNG,GIF,TIFF之一,宽和高必须大于8px，小于等于4000px,要求原始图片大小不超过5M
        // watermark_image 需上传的水印照，base64编码后进行URLEncode,格式必须为JPG（JPEG），BMP，PNG，TIFF之一,宽和高必须大于 8px，小于等于480px,原始文件尺寸小于等于1MB
        $image1=file_get_contents('E:/1.jpg');
        $image1=base64_encode($image1);
        $image2=file_get_contents('E:/2.jpg');
        $image2=base64_encode($image2);
        $Post = array(
            'face_image' => $image1,
            'watermark_image' => $image2,
        );
        // 对param进行base64编码
        $XParam = base64_encode(json_encode($Param));
        // 令牌md5加密
        $XCheckSum = md5($Apikey.$XCurTime.$XParam);
        // 组装http请求头
        $headers = array();
        $headers[] = 'X-CurTime:'.$XCurTime;
        $headers[] = 'X-Param:'.$XParam;
        $headers[] = 'X-Appid:'.$XAppid;
        $headers[] = 'X-CheckSum:'.$XCheckSum;
        $headers[] = 'Content-Type:application/x-www-form-urlencoded; charset=utf-8';
        echo $this->http_request($api, $Post, $headers);
    }
    function http_request($url, $post_data, $headers) {
        $postdata = http_build_query($post_data);
        $options = array(
            'http' => array(
                'method' => 'POST',
                'header' => $headers,
                'content' => $postdata,
                'timeout' => 15*60
            )
        );
        $context = stream_context_create($options);
        $result = file_get_contents($url, false, $context);
        echo $result;
        # 返回json串,错误码链接：https://www.xfyun.cn/document/error-code (code返回错误码时必看)
        return "success";
    }
}
$a = new test();
$a->xfyun();
?>